package ru.ulstu.paper.model;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.Date;

public class PaperDto {
    private final String title;
    private final Paper.PaperStatus status;
    private final Date createDate;
    private final Date updateDate;
    private final String comment;
    private final Boolean locked;
    private final String tmpFileName;
    private final Integer fileId;
    private final String fileName;
    private final Date fileCreateDate;

    @JsonCreator
    public PaperDto(@JsonProperty("title") String title,
                    @JsonProperty("status") Paper.PaperStatus status,
                    @JsonProperty("createDate") Date createDate,
                    @JsonProperty("updateDate") Date updateDate,
                    @JsonProperty("comment") String comment,
                    @JsonProperty("locked") Boolean locked,
                    @JsonProperty("tmpFileName") String tmpFileName) {
        this.title = title;
        this.status = status;
        this.createDate = createDate;
        this.updateDate = updateDate;
        this.comment = comment;
        this.locked = locked;
        this.tmpFileName = tmpFileName;
        this.fileId = null;
        this.fileName = null;
        this.fileCreateDate = null;
    }

    public PaperDto(Paper paper) {
        this.title = paper.getTitle();
        this.status = paper.getStatus();
        this.createDate = paper.getCreateDate();
        this.updateDate = paper.getUpdateDate();
        this.comment = paper.getComment();
        this.locked = paper.getLocked();
        this.tmpFileName = null;
        this.fileId = paper.getFile() == null ? null : paper.getFile().getId();
        this.fileName = paper.getFile() == null ? null : paper.getFile().getName();
        this.fileCreateDate = paper.getFile() == null ? null : paper.getFile().getCreateDate();
    }

    public String getTitle() {
        return title;
    }

    public Paper.PaperStatus getStatus() {
        return status;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public Date getUpdateDate() {
        return updateDate;
    }

    public String getComment() {
        return comment;
    }

    public Boolean getLocked() {
        return locked;
    }

    public String getTmpFileName() {
        return tmpFileName;
    }

    public Integer getFileId() {
        return fileId;
    }

    public String getFileName() {
        return fileName;
    }

    public Date getFileCreateDate() {
        return fileCreateDate;
    }
}
